commit 690d2d30ebdc5106e7892ef522a5ba7f4fbf0ecb
Author: Dominic Cleal <dcleal@redhat.com>
Date:   Thu May 29 15:05:57 2014 +0100

    Modernise and update for EL7

diff --git a/rel-eng/tito.props b/rel-eng/tito.props
index f58ab1113..df73f2801 100644
--- a/rel-eng/tito.props
+++ b/rel-eng/tito.props
@@ -93,6 +93,7 @@ whitelist = foreman-installer
 disttag = .el7
 whitelist = foreman-proxy
   foreman-selinux
+  rubygem-ansi
   rubygem-apipie-bindings
   rubygem-awesome_print
   rubygem-bundler_ext
@@ -102,6 +103,7 @@ whitelist = foreman-proxy
   rubygem-ffi
   rubygem-hammer_cli
   rubygem-hammer_cli_foreman
+  rubygem-hashie
   rubygem-highline
   rubygem-little-plugger
   rubygem-locale
@@ -110,6 +112,7 @@ whitelist = foreman-proxy
   rubygem-multi_json
   rubygem-netrc
   rubygem-oauth
+  rubygem-powerbar
   rubygem-rack
   rubygem-rack-protection
   rubygem-rest-client
diff --git a/rubygem-ansi/rubygem-ansi.spec b/rubygem-ansi/rubygem-ansi.spec
index 4b814d2a1..37a17d0e5 100644
--- a/rubygem-ansi/rubygem-ansi.spec
+++ b/rubygem-ansi/rubygem-ansi.spec
@@ -4,34 +4,15 @@
 %global gem_name ansi
 
 %define _version 1.4.3
-%define _summary "The ANSI project is a superlative collection of ANSI escape code" 
-%define _url "https://github.com/rubyworks/ansi"
+%define _summary The ANSI project is a superlative collection of ANSI escape code
+%define _url https://github.com/rubyworks/ansi
 %define _license FreeBSD
 
 %define desc The ANSI project is a superlative collection of ANSI escape code related libraries enabling ANSI colorization and stylization of console output. Byte for byte ANSI is the best ANSI code library available for the Ruby programming language.
 
-%if 0%{?rhel} == 6 || 0%{?fedora} < 17
-%if "%{?scl}" == "ruby193"
-%define rubyabi 1.9.1
-%else
-%define rubyabi 1.8
-%endif
-%else
-%define rubyabi 1.9.1
-%endif
-
-%if 0%{?rhel} == 6 &&  "%{?scl}" != "ruby193"
-%global gem_dir %(ruby -rubygems -e 'puts Gem.dir' 2>/dev/null)
-%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{version}
-%global gem_cache %{gem_dir}/cache/%{gem_name}-%{version}.gem
-%global gem_spec %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
-%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
-%global gem_libdir %{gem_dir}/gems/%{gem_name}-%{version}/lib
-%endif
-
 Name:      %{?scl_prefix}rubygem-%{gem_name}
 Version:   %{_version}
-Release:   1%{?dist}  
+Release:   1%{?dist}
 Summary:   %{_summary}
 Group:     Development/Languages
 License:   %{_license}
@@ -41,21 +22,16 @@ Source0:   http://rubygems.org/downloads/%{gem_name}-%{version}.gem
 BuildArch: noarch
 Provides:  %{?scl_prefix}rubygem(%{gem_name}) = %{version}
 
-%if 0%{?fedora} > 18
+%if "%{?scl}" == "ruby193" || (0%{?rhel} == 6 && 0%{!?scl:1})
+Requires:  %{?scl_prefix}ruby(abi)
+BuildRequires: %{?scl_prefix}ruby(abi)
+%else
 Requires:  %{?scl_prefix}ruby(release)
-%else 
-Requires:  %{?scl_prefix}ruby(abi) = %{rubyabi}
+BuildRequires: %{?scl_prefix}ruby(release)
 %endif
 Requires:  %{?scl_prefix}rubygems
 
-%if 0%{?fedora} || "%{?scl}" == "ruby193"
 BuildRequires: %{?scl_prefix}rubygems-devel
-%endif
-%if 0%{?fedora} > 18
-BuildRequires: %{?scl_prefix}ruby(release)
-%else
-BuildRequires: %{?scl_prefix}ruby(abi) = %{rubyabi}
-%endif
 BuildRequires: %{?scl_prefix}rubygems
 
 %description
@@ -98,7 +74,7 @@ gem install -V --local --install-dir .%{gem_dir} --force --rdoc \
 mkdir -p %{buildroot}%{gem_dir}
 cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}
 
-%files 
+%files
 %dir %{gem_instdir}
 %exclude %{gem_cache}
 %exclude %{gem_instdir}/test
diff --git a/rubygem-hashie/rubygem-hashie.spec b/rubygem-hashie/rubygem-hashie.spec
index e596b9a08..c8b61b0b6 100644
--- a/rubygem-hashie/rubygem-hashie.spec
+++ b/rubygem-hashie/rubygem-hashie.spec
@@ -1,39 +1,20 @@
 %{?scl:%scl_package rubygems-%{gem_name}}
 %{!?scl:%global pkg_name %{name}}
 
-# check files-sections at the end of this file and 
+# check files-sections at the end of this file and
 
 %global gem_name hashie
 
 %define _version 2.0.5
-%define _summary "Your friendly neighborhood hash toolkit." 
-%define _url "https://github.com/intridea/hashie"
+%define _summary Your friendly neighborhood hash toolkit.
+%define _url https://github.com/intridea/hashie
 %define _license MIT
 
 %define desc Hashie is a small collection of tools that make hashes more powerful. Currently includes Mash (Mocking Hash) and Dash (Discrete Hash)
 
-%if 0%{?rhel} == 6 || 0%{?fedora} < 17
-%if "%{?scl}" == "ruby193"
-%define rubyabi 1.9.1
-%else
-%define rubyabi 1.8
-%endif
-%else
-%define rubyabi 1.9.1
-%endif
-
-%if 0%{?rhel} == 6 &&  "%{?scl}" != "ruby193"
-%global gem_dir %(ruby -rubygems -e 'puts Gem.dir' 2>/dev/null)
-%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{version}
-%global gem_cache %{gem_dir}/cache/%{gem_name}-%{version}.gem
-%global gem_spec %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
-%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
-%global gem_libdir %{gem_dir}/gems/%{gem_name}-%{version}/lib
-%endif
-
 Name:      %{?scl_prefix}rubygem-%{gem_name}
 Version:   %{_version}
-Release:   0%{?dist}  
+Release:   0%{?dist}
 Summary:   %{_summary}
 Group:     Development/Languages
 License:   %{_license}
@@ -43,21 +24,16 @@ Source0:   http://rubygems.org/downloads/%{gem_name}-%{version}.gem
 BuildArch: noarch
 Provides:  %{?scl_prefix}rubygem(%{gem_name}) = %{version}
 
-%if 0%{?fedora} > 18
+%if "%{?scl}" == "ruby193" || (0%{?rhel} == 6 && 0%{!?scl:1})
+Requires:  %{?scl_prefix}ruby(abi)
+BuildRequires: %{?scl_prefix}ruby(abi)
+%else
 Requires:  %{?scl_prefix}ruby(release)
-%else 
-Requires:  %{?scl_prefix}ruby(abi) = %{rubyabi}
+BuildRequires: %{?scl_prefix}ruby(release)
 %endif
 Requires:  %{?scl_prefix}rubygems
 
-%if 0%{?fedora} || "%{?scl}" == "ruby193"
 BuildRequires: %{?scl_prefix}rubygems-devel
-%endif
-%if 0%{?fedora} > 18
-BuildRequires: %{?scl_prefix}ruby(release)
-%else
-BuildRequires: %{?scl_prefix}ruby(abi) = %{rubyabi}
-%endif
 BuildRequires: %{?scl_prefix}rubygems
 
 %description
@@ -100,7 +76,7 @@ gem install -V --local --install-dir .%{gem_dir} --force --rdoc \
 mkdir -p %{buildroot}%{gem_dir}
 cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}
 
-%files 
+%files
 %exclude %{gem_instdir}/.gitignore
 %exclude %{gem_instdir}/.document
 %exclude %{gem_instdir}/.rspec
diff --git a/rubygem-powerbar/rubygem-powerbar.spec b/rubygem-powerbar/rubygem-powerbar.spec
index cbaf02601..a2188c54f 100644
--- a/rubygem-powerbar/rubygem-powerbar.spec
+++ b/rubygem-powerbar/rubygem-powerbar.spec
@@ -2,42 +2,20 @@
 %{?scl:%scl_package rubygems-%{gem_name}}
 %{!?scl:%global pkg_name %{name}}
 
-# check files-sections at the end of this file and 
+# check files-sections at the end of this file and
 
 %global gem_name powerbar
 
 %define _version 1.0.11
-%define _summary "The last progressbar-library you'll ever need" 
-%define _url "https://github.com/busyloop/powerbar"
+%define _summary The last progressbar-library you'll ever need
+%define _url https://github.com/busyloop/powerbar
 %define _license MIT
 
 %define desc The last progressbar-library you'll ever need
 
-Requires: %{?scl_prefix}rubygem(ansi) >= 1.4.0
-Requires: %{?scl_prefix}rubygem(hashie) >= 1.1.0
-
-%if 0%{?rhel} == 6 || 0%{?fedora} < 17
-%if "%{?scl}" == "ruby193"
-%define rubyabi 1.9.1
-%else
-%define rubyabi 1.8
-%endif
-%else
-%define rubyabi 1.9.1
-%endif
-
-%if 0%{?rhel} == 6 &&  "%{?scl}" != "ruby193"
-%global gem_dir %(ruby -rubygems -e 'puts Gem.dir' 2>/dev/null)
-%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{version}
-%global gem_cache %{gem_dir}/cache/%{gem_name}-%{version}.gem
-%global gem_spec %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
-%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
-%global gem_libdir %{gem_dir}/gems/%{gem_name}-%{version}/lib
-%endif
-
 Name:      %{?scl_prefix}rubygem-%{gem_name}
 Version:   %{_version}
-Release:   7%{?dist}  
+Release:   7%{?dist}
 Summary:   %{_summary}
 Group:     Development/Languages
 License:   %{_license}
@@ -47,21 +25,20 @@ Source0:   http://rubygems.org/downloads/%{gem_name}-%{version}.gem
 BuildArch: noarch
 Provides:  %{?scl_prefix}rubygem(%{gem_name}) = %{version}
 
-%if 0%{?fedora} > 18
+Requires:  %{?scl_prefix}rubygem(ansi) >= 1.4.0
+Requires:  %{?scl_prefix}rubygem(ansi) <  1.5.0
+Requires:  %{?scl_prefix}rubygem(hashie) >= 1.1.0
+
+%if "%{?scl}" == "ruby193" || (0%{?rhel} == 6 && 0%{!?scl:1})
+Requires:  %{?scl_prefix}ruby(abi)
+BuildRequires: %{?scl_prefix}ruby(abi)
+%else
 Requires:  %{?scl_prefix}ruby(release)
-%else 
-Requires:  %{?scl_prefix}ruby(abi) = %{rubyabi}
+BuildRequires: %{?scl_prefix}ruby(release)
 %endif
 Requires:  %{?scl_prefix}rubygems
 
-%if 0%{?fedora} || "%{?scl}" == "ruby193"
 BuildRequires: %{?scl_prefix}rubygems-devel
-%endif
-%if 0%{?fedora} > 18
-BuildRequires: %{?scl_prefix}ruby(release)
-%else
-BuildRequires: %{?scl_prefix}ruby(abi) = %{rubyabi}
-%endif
 BuildRequires: %{?scl_prefix}rubygems
 
 %description
@@ -104,7 +81,7 @@ gem install -V --local --install-dir .%{gem_dir} --force --rdoc \
 mkdir -p %{buildroot}%{gem_dir}
 cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}
 
-%files 
+%files
 %exclude %{gem_instdir}/.gitignore
 %exclude %dir %{gem_instdir}/ass
 %exclude %{gem_instdir}/ass/screenshot.png