commit 0892ac1fdbe900a8356303f054667989ed7795c3
Author: Dominic Cleal <dcleal@redhat.com>
Date:   Fri Sep 4 10:30:54 2015 +0100

    Add ace-rails-ap dependency

diff --git a/comps/comps-foreman-fedora19.xml b/comps/comps-foreman-fedora19.xml
index f88c5c975..65eb7d466 100644
--- a/comps/comps-foreman-fedora19.xml
+++ b/comps/comps-foreman-fedora19.xml
@@ -31,6 +31,7 @@
       <packagereq type="default">foreman-installer</packagereq>
       <packagereq type="default">rubygem-foreman_api</packagereq>
 
+      <packagereq type="default">rubygem-ace-rails-ap</packagereq>
       <packagereq type="default">rubygem-ansi</packagereq>
       <packagereq type="default">rubygem-apipie-bindings</packagereq>
       <packagereq type="default">rubygem-apipie-rails</packagereq>
@@ -107,6 +108,7 @@
         Do not edit this section manually and use ./comps_doc.sh script
       -->
       <!--RGD-START-->
+      <packagereq type="default">rubygem-ace-rails-ap-doc</packagereq>
       <packagereq type="default">rubygem-ansi-doc</packagereq>
       <packagereq type="default">rubygem-apipie-bindings-doc</packagereq>
       <packagereq type="default">rubygem-apipie-rails-doc</packagereq>
diff --git a/comps/comps-foreman-rhel6.xml b/comps/comps-foreman-rhel6.xml
index ab07aa646..bf73a06a0 100644
--- a/comps/comps-foreman-rhel6.xml
+++ b/comps/comps-foreman-rhel6.xml
@@ -39,6 +39,7 @@
 
       <packagereq type="default">tfm-mod_passenger</packagereq>
 
+      <packagereq type="default">tfm-rubygem-ace-rails-ap</packagereq>
       <packagereq type="default">tfm-rubygem-addressable</packagereq>
       <packagereq type="default">tfm-rubygem-ancestry</packagereq>
       <packagereq type="default">tfm-rubygem-ansi</packagereq>
@@ -207,6 +208,7 @@
       <packagereq type="default">rubygem-powerbar-doc</packagereq>
       <packagereq type="default">rubygem-rkerberos-doc</packagereq>
       <packagereq type="default">rubygem-rubyipmi-doc</packagereq>
+      <packagereq type="default">tfm-rubygem-ace-rails-ap-doc</packagereq>
       <packagereq type="default">tfm-rubygem-addressable-doc</packagereq>
       <packagereq type="default">tfm-rubygem-ancestry-doc</packagereq>
       <packagereq type="default">tfm-rubygem-ansi-doc</packagereq>
diff --git a/comps/comps-foreman-rhel7.xml b/comps/comps-foreman-rhel7.xml
index 2064b826a..23a9664f5 100644
--- a/comps/comps-foreman-rhel7.xml
+++ b/comps/comps-foreman-rhel7.xml
@@ -39,6 +39,7 @@
 
       <packagereq type="default">tfm-mod_passenger</packagereq>
 
+      <packagereq type="default">tfm-rubygem-ace-rails-ap</packagereq>
       <packagereq type="default">tfm-rubygem-addressable</packagereq>
       <packagereq type="default">tfm-rubygem-ancestry</packagereq>
       <packagereq type="default">tfm-rubygem-ansi</packagereq>
@@ -210,6 +211,7 @@
       <packagereq type="default">rubygem-rubyipmi-doc</packagereq>
       <packagereq type="default">rubygem-sinatra-doc</packagereq>
       <packagereq type="default">rubygem-tilt-doc</packagereq>
+      <packagereq type="default">tfm-rubygem-ace-rails-ap-doc</packagereq>
       <packagereq type="default">tfm-rubygem-addressable-doc</packagereq>
       <packagereq type="default">tfm-rubygem-ancestry-doc</packagereq>
       <packagereq type="default">tfm-rubygem-ansi-doc</packagereq>
diff --git a/rel-eng/tito.props b/rel-eng/tito.props
index 349507e9c..b4ecbef3d 100644
--- a/rel-eng/tito.props
+++ b/rel-eng/tito.props
@@ -110,6 +110,7 @@ whitelist = foreman
   foreman-installer
   foreman-proxy
   foreman-selinux
+  rubygem-ace-rails-ap
   rubygem-apipie-rails
   rubygem-ansi
   rubygem-apipie-bindings
diff --git a/rubygem-ace-rails-ap/ace-rails-ap-3.0.3.gem b/rubygem-ace-rails-ap/ace-rails-ap-3.0.3.gem
new file mode 120000
index 000000000..d3b2d3d7b
--- /dev/null
+++ b/rubygem-ace-rails-ap/ace-rails-ap-3.0.3.gem
@@ -0,0 +1 @@
+../.git/annex/objects/Zq/6m/SHA256E-s1808384--24ae9fcba118d179de5e2fbfd0eb17f2fe1c96bde6303cbab8a2f3e430b6bd58.3.gem/SHA256E-s1808384--24ae9fcba118d179de5e2fbfd0eb17f2fe1c96bde6303cbab8a2f3e430b6bd58.3.gem
\ No newline at end of file
diff --git a/rubygem-ace-rails-ap/rubygem-ace-rails-ap.spec b/rubygem-ace-rails-ap/rubygem-ace-rails-ap.spec
new file mode 100644
index 000000000..22edaa02d
--- /dev/null
+++ b/rubygem-ace-rails-ap/rubygem-ace-rails-ap.spec
@@ -0,0 +1,71 @@
+%{?scl:%scl_package rubygem-%{gem_name}}
+%{!?scl:%global pkg_name %{name}}
+
+%global gem_name ace-rails-ap
+
+Summary: The Ajax.org Cloud9 Editor (Ace) for the Rails asset pipeline
+Name: %{?scl_prefix}rubygem-%{gem_name}
+Version: 3.0.3
+Release: 1%{?dist}
+Group: Development/Libraries
+License: MIT
+URL: https://github.com/codykrieger/ace-rails-ap
+Source0: http://rubygems.org/downloads/%{gem_name}-%{version}.gem
+
+%if 0%{?fedora} > 18
+Requires: %{?scl_prefix_ruby}ruby(release)
+BuildRequires: %{?scl_prefix_ruby}ruby(release)
+%else
+Requires: %{?scl_prefix_ruby}ruby(abi)
+BuildRequires: %{?scl_prefix_ruby}ruby(abi)
+%endif
+Requires: %{?scl_prefix_ruby}rubygems
+BuildRequires: %{?scl_prefix_ruby}rubygems-devel
+BuildRequires: %{?scl_prefix_ruby}rubygems
+BuildArch: noarch
+Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}
+
+%description
+The Ajax.org Cloud9 Editor (Ace) for the Rails 3.1+ asset pipeline.
+
+%package doc
+BuildArch:  noarch
+Requires:   %{?scl_prefix}%{pkg_name} = %{version}-%{release}
+Summary:    Documentation for rubygem-%{gem_name}
+
+%description doc
+This package contains documentation for rubygem-%{gem_name}.
+
+%prep
+%setup -n %{pkg_name}-%{version} -q -c -T
+mkdir -p .%{gem_dir}
+%{?scl:scl enable %{scl} "}
+gem install --local --install-dir .%{gem_dir} \
+            --force %{SOURCE0} --no-rdoc --no-ri
+%{?scl:"}
+
+%build
+
+%install
+mkdir -p %{buildroot}%{gem_dir}
+cp -a .%{gem_dir}/* \
+        %{buildroot}%{gem_dir}/
+
+%files
+%dir %{gem_instdir}
+%{gem_libdir}
+%{gem_instdir}/vendor
+%exclude %{gem_cache}
+%{gem_spec}
+%doc %{gem_instdir}/LICENSE
+
+%exclude %{gem_instdir}/.*
+%exclude %{gem_instdir}/*.gemspec
+%exclude %{gem_instdir}/Gemfile
+%exclude %{gem_instdir}/update.sh
+
+%files doc
+%doc %{gem_instdir}/README.md
+%{gem_instdir}/Rakefile
+
+%changelog