commit 4ba2e925e0e2963deae094f5eebc49ce6c754788
Author: Dominic Cleal <dcleal@redhat.com>
Date:   Thu May 29 19:06:18 2014 +0100

    refs #4451 - modernise spec for EL7

diff --git a/rel-eng/tito.props b/rel-eng/tito.props
index da1ac8427..9bb843279 100644
--- a/rel-eng/tito.props
+++ b/rel-eng/tito.props
@@ -115,6 +115,7 @@ whitelist = foreman-proxy
   rubygem-multi_json
   rubygem-netrc
   rubygem-oauth
+  rubygem-passenger
   rubygem-powerbar
   rubygem-rack
   rubygem-rack-protection
diff --git a/rubygem-net-ldap/rubygem-net-ldap.spec b/rubygem-net-ldap/rubygem-net-ldap.spec
index f853534a2..2944fa526 100644
--- a/rubygem-net-ldap/rubygem-net-ldap.spec
+++ b/rubygem-net-ldap/rubygem-net-ldap.spec
@@ -2,9 +2,6 @@
 %{!?scl:%global pkg_name %{name}}
 
 %global gem_name net-ldap
-%if 0%{?rhel} == 6 || 0%{?fedora} < 17
-%global gem_libdir %{gem_instdir}/lib
-%endif
 
 Summary: Net::LDAP for Ruby implements client access LDAP protocol
 Name: %{?scl_prefix}rubygem-%{gem_name}
diff --git a/rubygem-passenger/rubygem-passenger.spec b/rubygem-passenger/rubygem-passenger.spec
index 4950dac1c..e04ac8a6b 100644
--- a/rubygem-passenger/rubygem-passenger.spec
+++ b/rubygem-passenger/rubygem-passenger.spec
@@ -3,11 +3,10 @@
 %{!?scl:%global pkg_name %{name}}
 %{?scl:%scl_package rubygem-%{gem_name}}
 
-%if 0%{?fedora} >= 19
+%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
 %global gem_extdir %{gem_extdir_mri}
 %endif
 
-%if 0%{?rhel} <= 6
 %if 0%{?scl:1}
 %{!?gem_extdir:%global gem_extdir %{_libdir}/gems/exts/%{gem_name}-%{version}}
 %global gem_extdir_lib %{gem_extdir}/lib
@@ -15,7 +14,6 @@
 %{!?gem_extdir:%global gem_extdir %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")}
 %global gem_extdir_lib %{gem_extdir}
 %endif
-%endif
 
 %{!?_root_includedir:%global _root_includedir %{_includedir}}
 %{!?_httpd_apxs:       %{expand: %%global _httpd_apxs       %%{_sbindir}/apxs}}
@@ -25,6 +23,12 @@
 %{!?_httpd_modconfdir: %{expand: %%global _httpd_modconfdir %%{_sysconfdir}/httpd/conf.d}}
 %{!?_httpd_moddir:    %{expand: %%global _httpd_moddir    %%{_libdir}/httpd/modules}}
 
+%if 0%{?rhel} == 7 && 0%{!?scl:1}
+%global enable_check 0
+%else
+%global enable_check 1
+%endif
+
 Summary: Passenger Ruby web application server
 Name: %{?scl_prefix}rubygem-%{gem_name}
 Version: 4.0.18
@@ -83,7 +87,11 @@ Requires: %{?scl_prefix}rubygems
 #Requires: %{?scl_prefix}rubygem(daemon_controller) >= 1.0.0
 Requires: %{?scl_prefix}rubygem(rack)
 Requires: %{?scl_prefix}rubygem(rake)
+%if "%{?scl}" == "ruby193" || (0%{?rhel} == 6 && 0%{!?scl:1})
 Requires: %{?scl_prefix}ruby(abi)
+%else
+Requires: %{?scl_prefix}ruby(release)
+%endif
 
 %if 0%{?rhel} >= 6 || 0%{?fedora} >= 15
 BuildRequires:  libcurl-devel
@@ -108,7 +116,9 @@ BuildRequires: %{?scl_prefix}rubygems
 BuildRequires: %{?scl_prefix}rubygems-devel
 BuildRequires: %{?scl_prefix}rubygem(rake) >= 0.8.1
 BuildRequires: %{?scl_prefix}rubygem(rack)
+%if %{enable_check}
 BuildRequires: %{?scl_prefix}rubygem(rspec)
+%endif
 BuildRequires: %{?scl_prefix}rubygem(mime-types)
 # BuildRequires: source-highlight
 
@@ -365,7 +375,9 @@ sed -i \
 
 %{__cp} test/config.json.example test/config.json
 
+%if %{enable_check}
 rake test --trace ||:
+%endif
 
 %files
 %doc %{gem_instdir}/README.md
@@ -402,6 +414,9 @@ rake test --trace ||:
 %{gem_instdir}/ext
 
 %files -n %{?scl_prefix}mod_passenger
+%if 0%{?rhel} >= 7
+%config(noreplace) %{_httpd_confdir}/*.conf
+%endif
 %config(noreplace) %{_httpd_modconfdir}/*.conf
 %{_httpd_moddir}/mod_passenger.so
 %doc doc/Users?guide?Apache.txt
diff --git a/rubygem-unf/rubygem-unf.spec b/rubygem-unf/rubygem-unf.spec
index 3ae849d81..44971fd41 100644
--- a/rubygem-unf/rubygem-unf.spec
+++ b/rubygem-unf/rubygem-unf.spec
@@ -3,15 +3,6 @@
 
 %global gem_name unf
 
-%if !("%{?scl}" == "ruby193" || 0%{?rhel} > 6 || 0%{?fedora} > 16)
-%global gem_dir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
-%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
-%global gem_libdir %{gem_instdir}/lib
-%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{version}
-%global gem_cache %{gem_dir}/cache
-%global gem_spec %{gem_dir}/specifications
-%endif
-
 Name: %{?scl_prefix}rubygem-%{gem_name}
 Version: 0.1.3
 Release: 3%{?dist}
@@ -30,10 +21,7 @@ Requires: %{?scl_prefix}rubygems
 
 Requires: %{?scl_prefix}rubygem(unf_ext)
 
-%if (0%{?fedora} || "%{?scl}" == "ruby193")
 BuildRequires: %{?scl_prefix}rubygems-devel
-%endif
-
 %if 0%{?fedora}
 BuildRequires: %{?scl_prefix}ruby(release)
 %else
diff --git a/rubygem-unf_ext/rubygem-unf_ext.spec b/rubygem-unf_ext/rubygem-unf_ext.spec
index 48b0109b2..a650c7d4d 100644
--- a/rubygem-unf_ext/rubygem-unf_ext.spec
+++ b/rubygem-unf_ext/rubygem-unf_ext.spec
@@ -3,15 +3,6 @@
 
 %global gem_name unf_ext
 
-%if !("%{?scl}" == "ruby193" || 0%{?rhel} > 6 || 0%{?fedora} > 16)
-%global gem_dir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
-%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
-%global gem_libdir %{gem_instdir}/lib
-%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{version}
-%global gem_cache %{gem_dir}/cache
-%global gem_spec %{gem_dir}/specifications
-%endif
-
 Name: %{?scl_prefix}rubygem-%{gem_name}
 Version: 0.0.6
 Release: 4%{?dist}
@@ -28,10 +19,7 @@ Requires: %{?scl_prefix}ruby(abi)
 Requires: %{?scl_prefix}rubygems
 %endif
 
-%if (0%{?fedora} || "%{?scl}" == "ruby193")
 BuildRequires: %{?scl_prefix}rubygems-devel
-%endif
-
 %if 0%{?fedora}
 BuildRequires: %{?scl_prefix}ruby(release)
 %else